/* TheBridge.java
 * By: Jason Hiatt
 * Date: 4/2/2002
 * This class will determine if the packet is headed for the web server
 * or the IRC server.  This class creates a socket to the chosen service and
 * then relays it back to the client.
 */ 

import java.net.*;
import java.io.*;
import java.net.URL;

public class TheBridge extends Thread{

	public Socket socket = null;
	public Socket http = null;
   	public Socket irc = null;
	public Socket other = null;
	public String[] httpstuff = new String[200];
   	public String[] ircstuff = new String[200];
	public String[] otherstuff = new String[500];
   	public int counter = 0;
	public int hostline = 0;
	public int lastline = 0;
	public String filename;
	public int threads = 0;
	public int pass = 0;
	public boolean foundhost = false;
	public String inputLine;
	public boolean otherservice = true;
	public PrintWriter out;
	public BufferedReader in;

	public TheBridge(Socket socket, int threads){
		super("TheBridge" + threads);
		this.socket = socket;
		this.threads = threads;
		inputLine = ("Thread #" + threads + " is running");
  	}//End Constructor

	public void run(){

		try{
       		//Create I/O streams
			out = new PrintWriter(socket.getOutputStream(), true);
    	   		in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
			String outputLine = null;
           		int length = 0;
           		String temp = "";
           		boolean isapache = false;
           		boolean isIRC = false;
			boolean isOther = false;

			socket.setSoTimeout(5000);
			socket.setTcpNoDelay(true);

			//Listen for requests from the client
			while ((inputLine = in.readLine()) != null) {
	        		otherservice = false;
				System.out.println(inputLine);
				outputLine = inputLine;
				//We just want to look at the first request   
				if (counter == 0){
					length = outputLine.length();

					//Strip the header and see if it is a HTTP request 
					if(length > 9){
	           			temp = outputLine.substring((length - 8), (length - 4));
					}//End If

	           			if(temp.equals("HTTP")){
						isapache = true;
					}//End If

					//Strip the header and see if it is a IRC request    
					temp = null;
					if(length > 5){
       		  	       		temp = outputLine.substring(0,4);
               			}//End If
					else{
						break;
					}//End Else
					if((temp.equals("NICK")) || (temp.equals("USER"))){
	               				isIRC = true;
       	    			}//End If

				}//End If

				//If the request was for the HTTP server create a socket to the web server
				//and forward the request to it
                		if(isapache){

					httpstuff[counter] = outputLine;

					if (counter == 0){
						makeHTTPSocket();
						filename = getFilename();
            	 			}//End If

					if (outputLine.startsWith("Host:")){
						hostline = counter;
						foundhost = true;
        	     			}//End If

					if (foundhost){
            					if (threads > 15){
						try{
							sleep(20);
						}//End Try
						catch(InterruptedException e){
							System.out.println("Thread Problems");
						}//End Catch
    					}//End If
					new sendtoHTTP(http, socket, counter, out, httpstuff, hostline, filename).start();
					foundhost = false;
					pass++;
				}//End If

			}//End If

			//If the request was for the HTTP server create a socket to the web server
			//and forward the request to it
			else if(isIRC){
				if (counter == 0){
					makeIRCSocket();
      				}//End If
				ircstuff[counter] = outputLine;
               	 	if(counter >= 1){
					new sendtoIRC(irc, counter, lastline, ircstuff, out, in).start();
					lastline = counter;
					lastline++;
				}//End If
			}//End Else If

			//If the request was for neither service ignore it
			else{
				return;
			}//End Else

			//Clear out the IRCStuff buffer
			if (counter >= 199){
				int clear;
				for(clear = 0; clear < 199; clear++){
					ircstuff[clear] = null;
					otherstuff[clear] = null;
				}//End For
				lastline = 1;
				counter = 0;
			}//End If
			counter++;
		}//End While

		out.close();
      		in.close();
		socket.close();

		}//End Try
		catch (IOException e){
			if (otherservice){
				try{
					socket.setSoTimeout(0);
				}//End Try
				catch(IOException ee){
					e.printStackTrace();
				}//End Catch
				makeOtherSocket();
				new sendtoPOP3(other, counter, lastline, otherstuff, out, in).start();
			}//End If
			//e.printStackTrace();
			System.out.println("Later Dude!");
		}//End Catch

	}//End run

	public void makeIRCSocket(){

		try{
			irc = new Socket("linux.usi.edu", 1337);
		}//End Try
		catch(UnknownHostException e){
			e.printStackTrace();
			System.out.println("IRCSockets suck!");
		}//End Catch
		catch (IOException e){
	    		e.printStackTrace();
			System.out.println("IRC I/O sucks!");
		}//End Catch
	}//End makeIRCSocket

	public void makeHTTPSocket(){

		try{
			http = new Socket("linux.usi.edu", 81);
		}//End Try
		catch(UnknownHostException e){
			e.printStackTrace();
			System.out.println("HTTPSockets suck!");
		}//End Catch
		catch (IOException e){
			e.printStackTrace();
			System.out.println("HTTP I/O sucks!");
		}//End Catch
	}//End makeHTTPSocket
	public void makeOtherSocket(){

		try{
			other = new Socket("mail.usieagles.org", 110);
		}//End Try
		catch(UnknownHostException e){
			e.printStackTrace();
			System.out.println("OtherSockets suck!");
		}//End Catch
		catch (IOException e){
			e.printStackTrace();
			System.out.println("Other I/O sucks!");
		}//End Catch
	}//End makeOtherSocket

	public String getFilename(){

		// Strip the HTTP request and find the filename of the file requested 
		String temp;
		String temp1;
		int length = 0;
		length = httpstuff[0].length();
		temp = httpstuff[0].substring(4, (length - 8));
		length = temp.length();
		temp1 = temp.substring(1, (length - 1));
		return temp1;
	}//End getFilename

}//End TheBridge class
