#!/usr/bin/perl

print"What is your hostname? ";
$hostname = <STDIN>;
chop $hostname;

print"What port do you want JavaSwitch to run on? ";
$port = <STDIN>;
chop $port;

open JS, ">JavaSwitch.java";

print JS"/* JavaSwitch-1.0	By: Jason Hiatt\n";
print JS" * This creates the port that JavaSwitch will listen on.\n";
print JS" * Whenever a client connects a thread will be created for\n";
print JS" * \"TheBridge\" class.\n";
print JS" */ \n\n";
print JS"import java.net.*;\n";
print JS"import java.io.*;\n\n";
print JS"public class JavaSwitch{\n";
print JS"    public static void main(String[] args) throws IOException {\n\n";
print JS"		ServerSocket serverSocket = null;\n";
print JS"		boolean listening = true;\n";
print JS"		int threads = 0;\n\n";
print JS"		try{\n";
print JS"    		serverSocket = new ServerSocket($port);\n";
print JS"    	}//End Try\n";
print JS"		catch (IOException e){\n";
print JS"    		System.err.println(\"Could not listen on port:$port\");\n";
print JS"    	    System.exit(-1);\n";
print JS"		}//End Catch\n\n";
print JS"		while (listening){\n";
print JS"			threads++;\n";
print JS"			new TheBridge(serverSocket.accept(), threads).start();\n";
print JS"		}//End While\n";
print JS"		serverSocket.close();\n";
print JS"		threads--;\n\n";

print JS"    }//End Main\n\n";

print JS"}//End JavaSwitch\n";

close JS;

print"JavaSwitch can now run 3 services on 1 port.  Two of the three services have to be HTTPD and IRCD, the third service is up to you.  You can pick from POP3, SMTP and Telnet.\n\n";

print"What port is your IRC server on? ";
$iport = <STDIN>;
chop $iport;

print"What port is your web server on? ";
$hport = <STDIN>;
chop $hport;

print"What is your web server's root directory? (Example: /var/www/html/)";
$rootdir = <STDIN>;
chop $rootdir;

print"Do you want to run a third service?";
$third = <STDIN>;
chop $third;

if(third == 'y'){
	
	print"Which service would you like to run?\n";
	print"1) Telnet\n";
	print"2) POP3\n";
	print"3) SMTP\n";

	$which = 0;
	$which = <STDIN>;
	chop $which;
	
	if($which == 1){
		print"What port is your Telnet sever on?";
		$tport = <STDIN>;
		chop $tport;
	}//End If
	
	if($which == 2){
		print"What port is your POP3 sever on?";
		$pport = <STDIN>;
		chop $pport;
	}//End If

	if($which == 3){
		print"What port is your SMTP sever on?";
		$sport = <STDIN>;
		chop $sport;
	}//End If

}//End If


open TB, ">TheBridge.java";

print TB"/* TheBridge.java\n";
print TB" * By: Jason Hiatt\n";
print TB" * Date: 4/2/2002\n";
print TB" * This class will determine if the packet is headed for the web server\n";
print TB" * or the IRC server.  This class creates a socket to the chosen service and\n";
print TB" * then relays it back to the client.\n";
print TB" */ \n\n";
print TB"import java.net.*;\n";
print TB"import java.io.*;\n";
print TB"import java.net.URL;\n\n";
print TB"public class TheBridge extends Thread{\n\n";
print TB"	public Socket socket = null;\n";
print TB"	public Socket http = null;\n";
print TB"   	public Socket irc = null;\n";
print TB"	public Socket other = null;\n";
print TB"	public String[] httpstuff = new String[200];\n";
print TB"   	public String[] ircstuff = new String[200];\n";
print TB"	public String[] otherstuff = new String[500];\n";
print TB"   	public int counter = 0;\n";
print TB"	public int hostline = 0;\n";
print TB"	public int lastline = 0;\n";
print TB"	public String filename;\n";
print TB"	public int threads = 0;\n";
print TB"	public int pass = 0;\n";
print TB"	public boolean foundhost = false;\n";
print TB"	public String inputLine;\n";
print TB"	public boolean otherservice = true;\n";
print TB"	public PrintWriter out;\n";
print TB"	public BufferedReader in;\n\n";
print TB"	public TheBridge(Socket socket, int threads){\n";
print TB"		super(\"TheBridge\" + threads);\n";
print TB"		this.socket = socket;\n";
print TB"		this.threads = threads;\n";
print TB"		inputLine = (\"Thread #\" + threads + \" is running\");\n";
print TB"  	}//End Constructor\n\n";
print TB"	public void run(){\n\n";
print TB"		try{\n";
print TB"       		//Create I/O streams\n";
print TB"			out = new PrintWriter(socket.getOutputStream(), true);\n";
print TB"    	   		in = new BufferedReader(new InputStreamReader(socket.getInputStream()));\n";
print TB"			String outputLine = null;\n";
print TB"           		int length = 0;\n";
print TB"           		String temp = \"\";\n";
print TB"           		boolean isapache = false;\n";
print TB"           		boolean isIRC = false;\n";
print TB"			boolean isOther = false;\n\n";
print TB"			socket.setSoTimeout(5000);\n";
print TB"			socket.setTcpNoDelay(true);\n\n";
print TB"			//Listen for requests from the client\n";
print TB"			while ((inputLine = in.readLine()) != null) {\n";
print TB"	        		otherservice = false;\n";
print TB"				System.out.println(inputLine);\n";
print TB"				outputLine = inputLine;\n";
print TB"				//We just want to look at the first request   \n";
print TB"				if (counter == 0){\n";
print TB"					length = outputLine.length();\n\n";
print TB"					//Strip the header and see if it is a HTTP request \n";
print TB"					if(length > 9){\n";
print TB"	           			temp = outputLine.substring((length - 8), (length - 4));\n";
print TB"					}//End If\n\n";
print TB"	           			if(temp.equals(\"HTTP\")){\n";
print TB"						isapache = true;\n";
print TB"					}//End If\n\n";
print TB"					//Strip the header and see if it is a IRC request    \n";
print TB"					temp = null;\n";
print TB"					if(length > 5){\n";
print TB"       		  	       		temp = outputLine.substring(0,4);\n";
print TB"               			}//End If\n";
print TB"					else{\n";
print TB"						break;\n";
print TB"					}//End Else\n";
print TB"					if((temp.equals(\"NICK\")) || (temp.equals(\"USER\"))){\n";
print TB"	               				isIRC = true;\n";
print TB"       	    			}//End If\n\n";
print TB"				}//End If\n\n";
print TB"				//If the request was for the HTTP server create a socket to the web server\n";
print TB"				//and forward the request to it\n";
print TB"                		if(isapache){\n\n";
print TB"					httpstuff[counter] = outputLine;\n\n";
print TB"					if (counter == 0){\n";
print TB"						makeHTTPSocket();\n";
print TB"						filename = getFilename();\n";
print TB"            	 			}//End If\n\n";
print TB"					if (outputLine.startsWith(\"Host:\")){\n";
print TB"						hostline = counter;\n";
print TB"						foundhost = true;\n";
print TB"        	     			}//End If\n\n";
print TB"					if (foundhost){\n";
print TB"            					if (threads > 15){\n";
print TB"						try{\n";
print TB"							sleep(20);\n";
print TB"						}//End Try\n";
print TB"						catch(InterruptedException e){\n";
print TB"							System.out.println(\"Thread Problems\");\n";
print TB"						}//End Catch\n";
print TB"    					}//End If\n";
print TB"					new sendtoHTTP(http, socket, counter, out, httpstuff, hostline, filename).start();\n";
print TB"					foundhost = false;\n";
print TB"					pass++;\n";
print TB"				}//End If\n\n";
print TB"			}//End If\n\n";
print TB"			//If the request was for the HTTP server create a socket to the web server\n";
print TB"			//and forward the request to it\n";
print TB"			else if(isIRC){\n";
print TB"				if (counter == 0){\n";
print TB"					makeIRCSocket();\n";
print TB"      				}//End If\n";
print TB"				ircstuff[counter] = outputLine;\n";
print TB"               	 	if(counter >= 1){\n";
print TB"					new sendtoIRC(irc, counter, lastline, ircstuff, out, in).start();\n";
print TB"					lastline = counter;\n";
print TB"					lastline++;\n";
print TB"				}//End If\n";
print TB"			}//End Else If\n\n";
print TB"			//If the request was for neither service ignore it\n";
print TB"			else{\n";
print TB"				return;\n";
print TB"			}//End Else\n\n";
print TB"			//Clear out the IRCStuff buffer\n";
print TB"			if (counter >= 199){\n";
print TB"				int clear;\n";
print TB"				for(clear = 0; clear < 199; clear++){\n";
print TB"					ircstuff[clear] = null;\n";
print TB"					otherstuff[clear] = null;\n";
print TB"				}//End For\n";
print TB"				lastline = 1;\n";
print TB"				counter = 0;\n";
print TB"			}//End If\n";
print TB"			counter++;\n";
print TB"		}//End While\n\n";			
print TB"		out.close();\n";
print TB"      		in.close();\n";
print TB"		socket.close();\n\n";
print TB"		}//End Try\n";
print TB"		catch (IOException e){\n";
print TB"			if (otherservice){\n";
print TB"				try{\n";
print TB"					socket.setSoTimeout(0);\n";
print TB"				}//End Try\n";
print TB"				catch(IOException ee){\n";
print TB"					e.printStackTrace();\n";
print TB"				}//End Catch\n";
if($which == 0){
	//Do nothing
}//End If

if($which == 1){
	print TB"				makeOtherSocket();\n";
	print TB"				new sendtoTelnet(other, counter, lastline, otherstuff, out, in).start();\n";
}//End If

if($which == 2){
	print TB"				makeOtherSocket();\n";
	print TB"				new sendtoPOP3(other, counter, lastline, otherstuff, out, in).start();\n";
}//End If

if($which == 3){
	print TB"				makeOtherSocket();\n";
	print TB"				new sendtoSMTP(other, counter, lastline, otherstuff, out, in).start();\n";
}//End If

print TB"			}//End If\n";
print TB"			//e.printStackTrace();\n";
print TB"			System.out.println(\"Later Dude!\");\n";
print TB"		}//End Catch\n\n";
print TB"	}//End run\n\n";
print TB"	public void makeIRCSocket(){\n\n";
print TB"		try{\n";
print TB"			irc = new Socket(\"$hostname\", $iport);\n";
print TB"		}//End Try\n";
print TB"		catch(UnknownHostException e){\n";
print TB"			e.printStackTrace();\n";
print TB"			System.out.println(\"IRCSockets suck!\");\n";
print TB"		}//End Catch\n";
print TB"		catch (IOException e){\n";
print TB"	    		e.printStackTrace();\n";
print TB"			System.out.println(\"IRC I/O sucks!\");\n";
print TB"		}//End Catch\n";
print TB"	}//End makeIRCSocket\n\n";
print TB"	public void makeHTTPSocket(){\n\n";
print TB"		try{\n";
print TB"			http = new Socket(\"$hostname\", $hport);\n";
print TB"		}//End Try\n";
print TB"		catch(UnknownHostException e){\n";
print TB"			e.printStackTrace();\n";
print TB"			System.out.println(\"HTTPSockets suck!\");\n";
print TB"		}//End Catch\n";
print TB"		catch (IOException e){\n";
print TB"			e.printStackTrace();\n";
print TB"			System.out.println(\"HTTP I/O sucks!\");\n";
print TB"		}//End Catch\n";
print TB"	}//End makeHTTPSocket\n";
print TB"	public void makeOtherSocket(){\n\n";
print TB"		try{\n";
if($which == 0){
	print TB"			other = new Socket();\n";
}//End If

if($which == 1){
	print TB"			other = new Socket(\"$hostname\", $tport);\n";
}//End If

if($which == 2){
	print TB"			other = new Socket(\"$hostname\", $pport);\n";
}//End If

if($which == 3){
	print TB"			other = new Socket(\"$hostname\", $sport);\n";
}//End If

print TB"		}//End Try\n";
print TB"		catch(UnknownHostException e){\n";
print TB"			e.printStackTrace();\n";
print TB"			System.out.println(\"OtherSockets suck!\");\n";
print TB"		}//End Catch\n";
print TB"		catch (IOException e){\n";
print TB"			e.printStackTrace();\n";
print TB"			System.out.println(\"Other I/O sucks!\");\n";
print TB"		}//End Catch\n";
print TB"	}//End makeOtherSocket\n\n";
print TB"	public String getFilename(){\n\n";
print TB"		// Strip the HTTP request and find the filename of the file requested \n";
print TB"		String temp;\n";
print TB"		String temp1;\n";
print TB"		int length = 0;\n";
print TB"		length = httpstuff[0].length();\n";
print TB"		temp = httpstuff[0].substring(4, (length - 8));\n";
print TB"		length = temp.length();\n";
print TB"		temp1 = temp.substring(1, (length - 1));\n";
print TB"		return temp1;\n";
print TB"	}//End getFilename\n\n";
print TB"}//End TheBridge class\n";

close TB;

open STH, ">sendtoHTTP.java";

print STH"import java.net.*;\n";
print STH"import java.io.*;\n";
print STH"import java.net.URL;\n\n";
print STH"public class sendtoHTTP extends Thread{\n\n";
print STH"	public int count = 0;\n";
print STH"	public PrintWriter out;\n";
print STH"	public Socket http;\n";
print STH"	public Socket socket;\n";
print STH"	public String[] httpstuff = new String[200];\n";
print STH"	public int hostline = 0;\n";
print STH"	public File file;\n";
print STH"	public String filename;\n";
print STH"	static final byte[] EOL = {(byte)'\\r', (byte)'\\n' };\n\n";
print STH"	public sendtoHTTP(Socket http, Socket socket, int count, PrintWriter out, String[] httpstuff, int hostline, String filename){\n\n";
print STH"		super(\"sendtoHTTP\");\n";
print STH"		this.http =  http;\n";
print STH"		this.socket = socket;\n";
print STH"		this.count = count;\n";
print STH"		this.out = out;\n";
print STH"		this.httpstuff = httpstuff;\n";
print STH"		this.hostline = hostline;\n";
print STH"		this.filename = filename;\n\n";
print STH"	}//End costructor\n\n";
print STH"	public void run(){\n\n";
print STH"		int i = 0;\n";
print STH"		try{\n";
print STH"           		String input;\n";
print STH"			String output = null;\n";
print STH"          		PrintWriter httpout = new PrintWriter(http.getOutputStream(), true);\n";
print STH"			BufferedReader httpin = new BufferedReader(new InputStreamReader(http.getInputStream()));\n";
print STH"			PrintStream ps = new PrintStream(socket.getOutputStream());\n";
print STH"			String temp = null;\n";
print STH"			String temp1 = null;\n";
print STH"			int len = 0;\n";
print STH"			boolean isfile = false;\n";
print STH"			boolean doitnow = false;\n";
print STH"			String path = \"$rootdir\";\n";
print STH"			String userpath = null;\n";
print STH"			String temppath = null;\n";
print STH"			int j = 0;\n";
print STH"			int k = 0;\n\n";
print STH"			while (i < (count + 1)){\n";
print STH"				if (i == 0){\n";
print STH"					httpout.println(httpstuff[i]);\n";
print STH"				}//End If\n\n";
print STH"				if (i == hostline){\n";
print STH"					httpout.println(httpstuff[i] + '\\n');\n";
print STH"        	    		}//End If\n";
print STH"        	    		i++;\n";
print STH"			}//End While\n\n";
print STH"			while ((input = httpin.readLine()) != null) {\n";
print STH"				output = input;\n";
print STH"				len = output.length();\n";
print STH"				i = 0;\n";
print STH"				if (len > 20){\n";
print STH"					temp = output.substring(14, 18);\n";
print STH"					temp1 = output.substring(0,12);\n";
print STH"					if (temp1.equals(\"Content-Type\")){\n";
print STH"						if (temp.equals(\"text\")){\n";
print STH"							isfile = false;\n";
print STH"						}//End If\n";
print STH"						else{\n";
print STH"							isfile = true;\n";
print STH"						}//End Else\n";
print STH"					}//End If\n";		
print STH"				}//End If\n\n";
print STH"				if(doitnow){\n";
print STH"					if(filename.startsWith(File.separator)){\n";
print STH"						filename = filename.substring(1);\n";
print STH"					}//End If\n";		
print STH"					if(filename.startsWith(\"~\")){\n";
print STH"						temppath = \"/public_html/\";\n";
print STH"						i = 0;\n";
print STH"						while(filename.charAt(i) != '/'){\n";
print STH"							i++;\n";
print STH"						}//End While\n";
print STH"						userpath = filename.substring(1,i);\n";
print STH"						path = new String(\"/home/\" + userpath + temppath);\n";
print STH"						filename = filename.substring(i);\n";
print STH"					}//End If\n\n";
print STH"					file = new File(path, filename);\n";
print STH"					sendFile(file,ps);\n";
print STH"				}//End If\n";
print STH"				else{\n";
print STH"				if((filename.endsWith(\".cgi\")) || (filename.endsWith(\".php\")) || (filename.endsWith(\".pl\"))){\n";
print STH"						j = 0;\n";
print STH"						while((input = httpin.readLine()) != null){\n";
print STH"							httpstuff[i] = null;\n";
print STH"							httpstuff[i] = input;\n";
print STH"							j++;\n";
print STH"						}//End While\n";
print STH"						while(k < j){\n";
print STH"							k++;\n";
print STH"						}//End While\n";
print STH"					}//End If		 	\n";
print STH"					out.println(output);\n";
print STH"				}//End Else\n\n";
print STH"				if (isfile == true){\n";
print STH"					doitnow = true;\n";
print STH"				}//End If\n";
print STH"			}//End While\n";
print STH"			httpout.close();\n";
print STH"	        	httpin.close();\n";
print STH"			http.close();\n";
print STH"		}//End Try\n";
print STH"        catch (IOException e){\n";
print STH"	   	e.printStackTrace();\n";
print STH"			System.out.println(\"HTTP sucks!\");\n";
print STH"		}//End Catch\n";
print STH"	}//End run\n";
print STH"	void sendFile(File file, PrintStream ps) throws IOException {\n\n";
print STH"		byte[] buf = new byte[2048];\n";
print STH"	    InputStream is = null;\n";
print STH"	    ps.write(EOL);\n";
print STH"		String temp = \"\";\n";
print STH"		temp = file.getAbsolutePath();\n";
print STH"		is = new FileInputStream(file.getAbsolutePath());\n";
print STH"	    try {\n";
print STH"	       	int n;\n";
print STH"	       	while ((n = is.read(buf)) > 0){\n";
print STH"	       	    ps.write(buf, 0, n);\n";
print STH"		    }//End While\n";
print STH"		}//End Try\n";
print STH"		catch(IOException e){\n";
print STH"			e.printStackTrace();\n";
print STH"		}//End Catch\n";
print STH"		finally{\n";
print STH"			is.close();\n";
print STH"		}//End Finally\n";
print STH"	}//End sendFile\n\n";
print STH"}//End sendtoHTTP class\n";

close STH;
